Subject: [Stox] Instant Messaging (draft-ietf-stox-im-00) and SIP Contact header field

From: Christer Holmberg <[email-masked]>
Date: Fri, 2 Aug 2013 10:13:45 +0000

Hi,

As I indicated at the STOX session, the SIP MESSAGE examples in the draft contain a Contact header field, which is explicitly forbidden.

Section 4 of RFC 3248 says:

	"MESSAGE requests do not initiate dialogs.  User Agents MUST NOT 
	insert Contact header fields into MESSAGE requests."

My question in the meeting was whether this is simply an editorial bug, or whether the Contact header field is actually used for something (there is nothing in the normative text), e.g. to ensure that
MESSAGE requests are routed to the correct user agents (someone mentioned that GRUU might be needed).

Regards,

Christer

---

From: Saúl Ibarra Corretgé <[email-masked]>
Date: Fri, 2 Aug 2013 12:41:32 +0200

Hi Christer,

> MESSAGE requests are routed to the correct user agents (someone mentioned that GRUU might be needed).

I was the one who mentioned GRUU. We do need it if we want to know who sent the message exactly, but since the -im spec just deals with pager mode messages maybe we can live with just strangulating the bare JID. Peter?

Regards,

--
Saúl Ibarra Corretgé
AG Projects

---

From: Christer Holmberg <[email-masked]>
Date: Fri, 2 Aug 2013 10:50:23 +0000

Hi,

If you want to signal who sent the message, I believe we can find another mechanism for that. 

The GRUU is not really intended to indicate user identity anyway, and IF you want to use GRUU I believe you need to define how the gateway gets assigned the GRUU.

Regards,

Christer

-----Alkuperäinen viesti-----
Lähettäjä: Saúl Ibarra Corretgé [mailto:[email-masked]] 
Lähetetty: 2. elokuuta 2013 13:42
Vastaanottaja: Christer Holmberg
Kopio: [email-masked]
Aihe: Re: [Stox] Instant Messaging (draft-ietf-stox-im-00) and SIP Contact header field

Hi Christer,

On Aug 2, 2013, at 12:13 PM, Christer Holmberg <[email-masked]> wrote:

> My question in the meeting was whether this is simply an editorial 
> bug, or whether the Contact header field is actually used for something (there is nothing in the normative text), e.g. to ensure that MESSAGE requests are routed to the correct user agents (someone mentioned that GRUU might be needed).
> 

Regards,

--
Saúl Ibarra Corretgé
AG Projects

---

From: Saúl Ibarra Corretgé <[email-masked]>
Date: Fri, 2 Aug 2013 12:54:04 +0200

> If you want to signal who sent the message, I believe we can find another mechanism for that. 

I guess we are open to suggestions :-)

> The GRUU is not really intended to indicate user identity anyway, and IF you want to use GRUU I believe you need to define how the gateway gets assigned the GRUU.

-core defines how we use GRUU which is required, in a nutshell, a GRUU is translated to a full JID and vice versa. Now, IIRC GRUUs are used just in the Contact header (which we can't use here) and not in the From header, for instance.

Regards,

--
Saúl Ibarra Corretgé
AG Projects

---

From: Saúl Ibarra Corretgé <[email-masked]>
Date: Fri, 2 Aug 2013 12:54:56 +0200

> If you want to signal who sent the message, I believe we can find another mechanism for that. 

One option would be to mandate the use of CPIM and set the From header of the CPIM envelope to the GRUU.

--
Saúl Ibarra Corretgé
AG Projects

---

From: Paul Kyzivat <[email-masked]>
Date: Wed, 14 Aug 2013 22:26:15 +0200

> If you want to signal who sent the message, I believe we can find another mechanism for that.

I don't think so. This is a *gateway* function. We aren't expecting the 
SIP or XMPP endpoints to do anything special. If the SIP user sends a 
MESSAGE, then that normally doesn't contain a URI of the sending 
endpoint. So we have nothing to put into the XMPP.

I could imagine using Reply-To for this purpose. There is nothing to 
*prevent* use of this. But neither is there currently any reason to 
expect that it will be used.

	Thanks,
	Paul

> _______________________________________________
> stox mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/stox
>

---

From: Paul Kyzivat <[email-masked]>
Date: Wed, 14 Aug 2013 22:29:01 +0200

> -core defines how we use GRUU which is required, in a nutshell, a GRUU is translated to a full JID and vice versa. Now, IIRC GRUUs are used just in the Contact header (which we can't use here) and…

There is nothing to *prevent* use of a gruu in From, but it isn't what 
is normally used.

If you happen to find a gruu in From, then it probably makes sense to 
translate it to a full JID.

	Thanks,
	Paul

---

From: Saúl Ibarra Corretgé <[email-masked]>
Date: Fri, 16 Aug 2013 10:14:18 +0200

> 
> There is nothing to *prevent* use of a gruu in From, but it isn't what is normally used.
> 
> If you happen to find a gruu in From, then it probably makes sense to translate it to a full JID.
> 

I thought it could only be used in the Contact header, but as you said, RFC5627 doesn't enforce that. So I guess we should mention this in the -im spec. This could also be used if someone writes a spec to map XMPP chat messages to SIP MESSAGE in the future.

Thanks!

--
Saúl Ibarra Corretgé
AG Projects

---

From: Peter Saint-Andre <[email-masked]>
Date: Mon, 19 Aug 2013 21:20:07 -0600

On 8/16/13 2:14 AM, Saúl Ibarra Corretgé wrote:
> I thought it could only be used in the Contact header, but as you
> said, RFC5627 doesn't enforce that. So I guess we should mention this
> in the -im spec. This could also be used if someone writes a spec to
> map XMPP chat messages to SIP MESSAGE in the future.
> 
> Thanks!

And in this instance the SIP From header would be added by the gateway,
right?

Peter

-- 
Peter Saint-Andre
https://stpeter.im/

---

From: Saúl Ibarra Corretgé <[email-masked]>
Date: Tue, 20 Aug 2013 09:13:51 +0200

> And in this instance the SIP From header would be added by the gateway,

Yes, by translating the from attribute of the XMPP message stanza. So I think we are good. It would be nice to have this in the examples, that is, no Contact header, and the GRUU in the From.

--
Saúl Ibarra Corretgé
AG Projects

---

From: Peter Saint-Andre <[email-masked]>
Date: Tue, 20 Aug 2013 08:49:17 -0600

> Yes, by translating the from attribute of the XMPP message stanza. So I think we are good. It would be nice to have this in the examples, that is, no Contact header, and the GRUU in the From.

Yes, that will be added in the next revision of the stox-im I-D. :-)

Peter

-- 
Peter Saint-Andre
https://stpeter.im/